/////////////////////////////////////////////
//Funkcje konfiguracji programu Txtburn-cpp//
/////////////////////////////////////////////
//The documentation about license is in license-gpl-2.0.txt
//This program was written in 2012 by Michał "mucha090" Kubicki
#include <iostream>
#include "naglowki.h"
#ifndef __WIN32__
#include <sys/io.h>   // For access().
#include <sys/types.h>  // For stat().
#include <sys/stat.h>   // For stat().
#endif

string prog_ext()
{
#ifdef __WIN32__
string prog_extend = ".exe";
#else
string prog_extend = "";
#endif
return prog_extend;
}

string txtburn_default_folder()
{
    //jak sama nazwa wskazuje funkcja ustawia domyślny folder w którym pojawią się inne foldery
#ifdef __WIN32__
    string default_folder = getexepath(); // dla windowsa i  tak będzie to folder w którym został uruchomiony program :P
#else
    int port;
    string default_folder;
    string strPath = getexepath() + "bin-linux"; string env = getenv("HOME"); string strPath2 = env + "/Txtburn/";
	//cout << strPath << endl << strPath2 << endl; // <- tak na przyszłość gdyby znów, funkcja getexepath() nawaliła
// to zawsze tak kontrolnie można sprawdzić czy aby ścieżki są pokazywane poprawnie
	if (( access( strPath.c_str(), 0 ) == 0 )&&( access( strPath2.c_str(), 0) != 0))
    {
        struct stat status; struct stat status2;
        stat( strPath.c_str(), &status );
		stat( strPath2.c_str(), &status2);
        if (( status.st_mode & S_IFDIR )&&(!( status2.st_mode & S_IFDIR )))
        {
            port = 1;
        }
    }
    else
    {
        port = 0;
    }
    if ((port == 0)) // jeśli wartość jest równa zeru to domyślny folder będzie się nazywał .txtburn
 	{
        string home_variable = getenv("HOME");
        default_folder = home_variable + "/Txtburn/"; // będzie on folderem ukrytym
        vector<string>home_var; vector<string>txtburn_dir;
        home_var.push_back(home_variable); txtburn_dir.push_back("/Txtburn/");
        runprog("mkdir ","-p ", home_var,"",txtburn_dir , ""); // i dodatkowo zostanie utworzony w katalogu domowym
    }
    else  // jeśli wartość zmiennej port będzie inna niż 0 to
        default_folder = getexepath(); // domyślnym folderem będzie ten w którym uruchomiony zostanie program
#endif
    return default_folder;
}

string txtburn_cfg_file()
{
#ifdef __WIN32__
    string txtburn_conf = getexepath() + "config\\txtburn.cfg";
    string null = " ";
    string dirin_str = getexepath() + "config";
    vector <string> dirin; dirin.push_back(dirin_str);
    vector <string> nic; nic.push_back(null);

    runprog("mkdir ", "", dirin,"", nic, "");
#else
    int port;
    string txtburn_conf;
	string strPath = getexepath() + "bin-linux"; string env = getenv("HOME"); string strPath2 = env + "/Txtburn/";
	//cout << strPath << endl << strPath2 << endl; // <- tak na przyszłość gdyby znów, funkcja getexepath() nawaliła
	// to zawsze tak kontrolnie można sprawdzić czy aby ścieżki są pokazywane poprawnie
	if (( access( strPath.c_str(), 0 ) == 0 )&&( access( strPath2.c_str(), 0) != 0))
    {
        struct stat status; struct stat status2;
        stat( strPath.c_str(), &status );
		stat( strPath2.c_str(), &status2);
        if (( status.st_mode & S_IFDIR )&&(!( status2.st_mode & S_IFDIR )))
        {
            port = 1;
        }
    }
    else
    {
        port = 0;
    }
    if ((port == 0))
    {
        string home_variable = getenv("HOME");
        txtburn_conf = home_variable + "/Txtburn/txtburn.cfg";
        vector<string>home_var; vector<string>txtburn_dir;
        home_var.push_back(home_variable); txtburn_dir.push_back("/Txtburn/");
        runprog("mkdir ","-p ", home_var,"",txtburn_dir , "");
    }
    else
    {
        vector<string>nic; vector<string>cfg_dir;
        nic.push_back(" "); cfg_dir.push_back(getexepath() + "config");
        runprog("mkdir ", "-p ",cfg_dir,"",nic, "");
        txtburn_conf = getexepath() + "config/txtburn.cfg";
    }
#endif
    return txtburn_conf;
}

int konfig_iMaxspeed(int iMAXSPEED)
{
    cout << PL(file2lang("speed_info"));
        do
        {
            cout << PL(file2lang("speed_info2"));
            cin >> iMAXSPEED;
            bool czyDobrze = cin.good();
        	cin.clear();
        	cin.ignore(1000, '\n');
       		blokada(czyDobrze, iMAXSPEED);
            if (((iMAXSPEED > 8)||(iMAXSPEED < 17))&&(!((iMAXSPEED < 9)||(iMAXSPEED > 16))))
            {
                cout << PL(file2lang("speed_warning"));
                break;
            }
            else;
        }
        while (((iMAXSPEED > 8)||(iMAXSPEED < 2)));

    return iMAXSPEED;
}



string konfig_naped_dvd(int ustaw)
{
    string devcdda;
    if (ustaw == 4)
    {
        cout << PL(file2lang("cdda_change_info1"));
    }
    else if (ustaw == 15)
    {
        cout << PL(file2lang("cdda_change_info2"));
    }
    else;
    	cout << PL(file2lang("cdda_change_info"));
#ifdef __WIN32__
    string null = " ";
    vector <string> nic; nic.push_back(null);
//-----------------------------------------------------------------------------------//
    runprog("wodim" + prog_ext(),  " --scanbus", nic,"",nic, "");
//-----------------------------------------------------------------------------------//
    cout << PL(file2lang("cdda_change_example"))
         << PL(file2lang("cdda_change_example_info"));
#else
//-----------------------------------------------------------------------------------//
    vector <string> nic; nic.push_back(" ");
    runprog("ls ", " -l /dev/",nic, " | grep sr",nic, "");
//-----------------------------------------------------------------------------------//
    cout << PL(file2lang("cdda_change_example2"))
		 << PL(file2lang("cdda_change_example2_info"));
#endif
    getline(cin, devcdda);
    cin.clear();
    cin.ignore(1000, '\n');
    return devcdda;
}

void return2default(kontenery_zmiennych_str &zmienneTxtburn)
{
    string default_folder = txtburn_default_folder();
    zmienneTxtburn.devname = devdvd;
    zmienneTxtburn.devcdda = devaudiocd;
    zmienneTxtburn.inDIRECTORY = default_folder + weDIRECTORY ;
    zmienneTxtburn.outDIRECTORY = default_folder + wyDIRECTORY ;
    zmienneTxtburn.VOLNAME = "txtburn"; // VOLNAME i ISONAME nie zostały tam z(#)definiowane
    zmienneTxtburn.ISONAME = "txtburn.iso";
    zmienneTxtburn.cdda2mp3dir = default_folder +  Cdda2mp3dir ;
    zmienneTxtburn.cdda2oggdir = default_folder +  Cdda2oggdir ;
    zmienneTxtburn.cdda2wavdir = default_folder +  Cdda2wavdir ;
    zmienneTxtburn.wav2mp3dir = default_folder +  Wav2mp3dir ;
    zmienneTxtburn.wav2oggdir = default_folder +  Wav2oggdir ;
    zmienneTxtburn.DEVICE = devdev + zmienneTxtburn.devname + "";
    zmienneTxtburn.DEVCDDA = devdev + zmienneTxtburn.devcdda + "";
    zmienneTxtburn.DIRIISO = zmienneTxtburn.outDIRECTORY + slashslash + zmienneTxtburn.ISONAME + "";
    zmienneTxtburn.MAXSPEED = "4";
    zmienneTxtburn.BUFFERSIZE = "14";
}

void about_Txtburn()
{
    clrscr();
	cout << PL(file2lang("program_name_info"))
		 << PL(file2lang("program_version")) << " // "
		 << __DATE__ << " || " << __TIME__ << endl;
    cout << PL(file2lang("program_info")) << endl;
    cout << PL(file2lang("path_info3")) << getexepath()
		 << PL(file2lang("path_info4")) << txtburn_default_folder() << endl;
    cout << PL(file2lang("press_enter4")) << endl;
    getchar();
    clrscr();
    cout << PL(file2lang("program_info2")) << endl;
    cout << PL(file2lang("press_enter5")) << endl;
    getchar();
    clrscr();
}

#ifdef __WIN32__ 
// specjalnie dla windowsa zrobiłem taką małą funkcje która jak widać poniżej
// prosi użytkownika o jednorazowe wpisanie nazwy swojego napędu cd/dvd
// po czym zapisuje to do pliku, a ten plik później zostaje odtworzony 
// (o ile użytkownik sobie nie zażyczył odczytania wartości głównego pliku cfg)
string check_DEVICE_WIN32(kontenery_zmiennych_str zmienneTxtburn)
{
	cout << PL(file2lang("check_dev_win32"));
	zmienneTxtburn.DEVICE = konfig_naped_dvd(0);
//-----------------------------------------------------------------------------------//
	string txtburn_conf_WIN32 = getexepath() + "config" + slashslash + "txtburn_WIN32_DEVICE.cfg";
	string pliczek = "DEVICE: " + zmienneTxtburn.DEVICE + "\n";
	ofstream txtburn_DEVICE_WIN32 (txtburn_conf_WIN32.c_str());
        if (txtburn_DEVICE_WIN32.is_open())
        {
            if (txtburn_DEVICE_WIN32.good())
                txtburn_DEVICE_WIN32 << pliczek << endl;
            txtburn_DEVICE_WIN32.close();
            cout << PL(file2lang("cfg_save_info_succ"));
        }
        else
            cout << PL(file2lang("file_error"));
//-----------------------------------------------------------------------------------//
return zmienneTxtburn.DEVICE;
}
#endif

void help_Txtburn() // taki mój wymysł, nie wiem czy to dokończe 
// bo najpierw program musi działać poprawnie na obu systemach
{//TODO *zrobić funkcje pomocy która by pomogła w ogarnięciu tego programu*
	cout << "Witam w module pomocy Txtburn.\n";
	cout << PL("Aktualnie ta funkcja pomocy obsługuje następujące menu: \n")
		<< PL("wypalanie - jeśli to wpiszesz to pokaże tobie\n")
		<< PL("w jaki sposób miał(a)byś się po tym menu poruszać\n\n")
		<< PL("audio_ripper - jeśli to wpiszesz to pokaże tobie \n")
		<< PL("w jaki sposób miał(a)byś się po tym menu poruszać\n\n")
		<< "konfiguracja_programu - wpisujac to otrzymasz pomoc \n"
		<< "w konfiguracji tego programu \n\n";
	cout << "Wiec w czym moge pomoc?\n";
}
