#include <iostream>
#include "naglowki.h" // Txtburn-c++
//The documentation about license is in license-gpl-2.0.txt
//This program was written in 2012 by Michał "mucha090" Kubicki

/* jest to główny plik tego programu, w nim mamy:
- zmienne programu
- główne menu
- konfiguracja ustawień programu (jako funkcja)
- wypalanie i rippowanie płyt audiocd (dwie osobne funckje)
- o programie
cała reszta jest rozproszona po plikach (jak i w/w :P)
ten plik posiada na chwile obecną ok. 166 linijek kodu
*/
using namespace std;

#ifndef __WIN32__
#include <locale.h>
#include <langinfo.h>
#include <string.h>
char terminal_charset[64];
#endif

string lang;

int main(int argc, char * argv[])
{

#ifndef __WIN32__
    setlocale(LC_ALL,"");
    strcpy(terminal_charset,nl_langinfo(CODESET));
    if (!strcasecmp(terminal_charset,"UTF-8")) terminal_charset[0]=0;
    else strcat(terminal_charset,"//TRANSLIT");
#endif

    kontenery_zmiennych_str zmienneTxtburn;
    string txtburn_conf = txtburn_cfg_file();
    // sprawdza gdzie ma zapisać plik konfiguracyjny txtburn.cfg
    // albo w folderze config (on będzie wykorzystany tylko gdy w nim znajdować się będzie plik portable
    // jeśli nie to skorzysta on z folderu ~/Txtburn/)
    //string apps = portable_apps();
    // w/w sprawdza z jakiego folderu mają być wykorzystane zew programy (tylko linux)
    // ex. albo z bin-linux będzie korzystał program albo z tego systemowego
    zmienneTxtburn.default_folder = txtburn_default_folder();
	string default_folder = zmienneTxtburn.default_folder;
    // w/w sprawdza jaki ma być domyślny folder do ustawień, etc.

    int iMAXSPEED = 4; // maksymalna prędkość wypalania
    int iBUFFERSIZE = 14; // bufor wypalania

    bool czyDobrze;

    stringstream string2int, string2int2;
    stringstream int2string, int2string2;
    // w/w zmienne są do przetrzymywania wartości int, i zostaną wykorzystane do przekazania i vice versa
    // ich do zmiennych std::string MAXSPEED i std::string BUFFERSIZE
//---------------------------------------------------------------//
//---------------------------------------------------------------//
    zmienneTxtburn.devname = devdvd;
    zmienneTxtburn.devcdda = devaudiocd;
//---------------------------------------------------------------//cdda2mp3dir, cdda2oggdir, cdda2wavdir, wav2mp3dir, wav2oggdir, DEVCDDA
//---------------------------------------------------------------//
    zmienneTxtburn.inDIRECTORY = default_folder + weDIRECTORY ;
    zmienneTxtburn.outDIRECTORY = default_folder + wyDIRECTORY ;
    zmienneTxtburn.VOLNAME = "txtburn";
    zmienneTxtburn.ISONAME = "txtburn.iso";
//---------------------------------------------------------------//
//---------------------------------------------------------------//
    zmienneTxtburn.cdda2mp3dir = default_folder +  Cdda2mp3dir ;
    zmienneTxtburn.cdda2oggdir = default_folder +  Cdda2oggdir ;
    zmienneTxtburn.cdda2wavdir = default_folder +  Cdda2wavdir ;
    zmienneTxtburn.wav2mp3dir = default_folder +  Wav2mp3dir ;
    zmienneTxtburn.wav2oggdir = default_folder +  Wav2oggdir ;
#ifndef __WIN32__
    zmienneTxtburn.DEVCDDA = devdev + zmienneTxtburn.devcdda + "";
    zmienneTxtburn.DEVICE = devdev + zmienneTxtburn.devname + "";
#endif
    zmienneTxtburn.DIRIISO = zmienneTxtburn.outDIRECTORY + slashslash + zmienneTxtburn.ISONAME + "";
    int2string << iMAXSPEED;
    zmienneTxtburn.MAXSPEED = int2string.str();
    int2string2 << iBUFFERSIZE;
    zmienneTxtburn.BUFFERSIZE = int2string2.str();
    zmienneTxtburn.nic = " ";
	
//---------------------------------------------------------------//
//---------------------------------------------------------------//
// sprawdzenie czy wczytać trzeba zmienne z pliku cfg czy użyć ich domyslnych wartości
    ifstream txtburn_cfg (txtburn_conf.c_str());
    string readONrun;
    if (txtburn_cfg.is_open())// kilka linijek niżej została opisana cała procedura
    {
        if (txtburn_cfg.good())
		readONrun = file2txtburn(txtburn_conf, "Read cfg at startup");
        txtburn_cfg.close();
    }
    else if (!(txtburn_cfg.is_open()))
        readONrun = "1";
//---------------------------------------------------------------// specjalnie dla wersji na windowsa (bleh, bleh, blehhhhh)
#ifdef __WIN32__
string txtburn_WIN32_DEVICE_cfg =  default_folder + "config\\txtburn_WIN32_DEVICE.cfg";
    ifstream txtburn_WIN32_DEVICE (txtburn_WIN32_DEVICE_cfg.c_str());// i przekazywanie jej do zmiennej
    if ((txtburn_WIN32_DEVICE.is_open())&&(readONrun == "1"))   // jeśli plik jest otwarty...
    {
        if (txtburn_WIN32_DEVICE.good())    // i ma się dobrze:P...
        {

			getline (txtburn_WIN32_DEVICE,zmienneTxtburn.DEVICE);// to pobierze się wartość do zmiennej
			getline (txtburn_WIN32_DEVICE,zmienneTxtburn.DEVCDDA);
		zmienneTxtburn.DEVICE = fixed_path(zmienneTxtburn.DEVICE, "DEVICE: ");
		zmienneTxtburn.DEVCDDA = fixed_path(zmienneTxtburn.DEVCDDA, "DEVICE: ");

		}txtburn_WIN32_DEVICE.close(); // zamknie się plik
    }
    else if (!(txtburn_WIN32_DEVICE.is_open()))  // a jeśli pliku nie uda się otworzyć to...
{
zmienneTxtburn.DEVICE = devdev + zmienneTxtburn.devname + "";
zmienneTxtburn.DEVCDDA = devdev + zmienneTxtburn.devcdda + "";
}
#endif
//---------------------------------------------------------------// koniec tego "dobrego"
// poczatek_prog, tutaj program się "przedstawia" użytkownikowi i tworzy niezbędne pliki/foldery
    string if_firstrun;                      // tutaj zaczyna się pobieranie wartości z pliku
    string firstrun_str =  default_folder + "firstrun.txt";
    ifstream firstrun (firstrun_str.c_str());// i przekazywanie jej do zmiennej line
    if (firstrun.is_open())   // jeśli plik jest otwarty...
    {
        if (firstrun.good())    // i ma się dobrze:P...
            getline (firstrun,if_firstrun);// to pobierze się wartość do zmiennej line
        firstrun.close(); // zamknie się plik
    }
    else if (!(firstrun.is_open()))  // a jeśli pliku nie uda się otworzyć to...
        if_firstrun = "0"; // wartość zmiennej line jest równa 0
    if ((if_firstrun == "0")) // no a tutaj jeśli zmienna line jest równa 0 to uruchomi się funkcja poczatek_prog
        poczatek_prog(zmienneTxtburn);

	string language_str =  default_folder + "language";
    ifstream language (language_str.c_str());// i przekazywanie jej do zmiennej line
    if (language.is_open())   // jeśli plik jest otwarty...
    {
        if (language.good())    // i ma się dobrze:P...
            getline (language, lang);// to pobierze się wartość do zmiennej line
        language.close(); // zamknie się plik
    }
    else if (!(language.is_open()))  // a jeśli pliku nie uda się otworzyć to...
        lang = ""; // wartość zmiennej line jest równa 0
    if ((lang == "")||(lang == " ")) // no a tutaj jeśli zmienna line jest równa 0 to uruchomi się funkcja poczatek_prog
        lang = set_lang();

string read_sukces = "";

    if (readONrun=="0")
    {
        file2string(zmienneTxtburn);
        stringstream string2int(zmienneTxtburn.MAXSPEED);
        stringstream string2int2(zmienneTxtburn.BUFFERSIZE);
        string2int >> iMAXSPEED;
        string2int2 >> iBUFFERSIZE;
        read_sukces = PL(file2lang("settings_read_success"));
    }	

int scrclronce = 1;

    do
    {
//główne menu
//---------------------------------------------------------------//
        if (scrclronce == 1)
        {/**/clrscr(); /* cout << zmienneTxtburn.DEVICE << "\n" << readONrun << endl;*/
	cout << read_sukces << endl;
	cout << PL(file2lang("path_info1")) << getexepath()
	     << PL(file2lang("path_info2")) << txtburn_default_folder() << endl;
	scrclronce = 0;}
//---------------------------------------------------------------//
//---------------------------------------------------------------//
        cout << PL(file2lang("welcome1"))
             << PL(file2lang("global_menu_info"))
             << PL(file2lang("main_menu_list"));
        int menu;
        cin >> menu;
        czyDobrze = cin.good();
        cin.clear();
        cin.ignore(1000, '\n');
		blokada(czyDobrze, menu);

        switch (menu)
        {
            // wypalanie płyt DVD/CD
        case 1:
            wypalanie(zmienneTxtburn);
            cout << PL(file2lang("main_menu_info2"));
            break;// koniec menu do wypalania płyt DVD/CD
            //rippowanie audiocd
        case 2:
            rippowanie(zmienneTxtburn);
            cout << PL(file2lang("main_menu_info2"));
            break; //koniec menu do rippowania płyt AudioCD i konwersji plików audio
            // konfiguracja programu
        case 3:
            ustaw_programu(iMAXSPEED, iBUFFERSIZE, zmienneTxtburn);
            cout << PL(file2lang("main_menu_info2"));
            break; //koniec menu edycji
            // o programie
        case 4:
            about_Txtburn();
            cout << PL(file2lang("main_menu_info2"));
            break; // koniec informacji o programie
            // Program exit
        case 5:
            clrscr();
            cout << PL(file2lang("exit_info"));
            return 0;
            break; // end of program exit
            // default info
        default:
            clrscr();
            cout << PL(file2lang("menu_not_found_info"));
            break; // end of default info
        }
    }
    while (!((cin.fail())));
    return 0;
}
